/**
 ** mouse3dMainCodels.c
 **
 ** Codels called by execution task mouse3dMain
 **
 ** Author:
 ** Date:
 **
 **/

#include <portLib.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "spnav.h"
#include "server/mouse3dHeader.h"

static int isInitialized = 0;
spnav_event mouse3d;

/*------------------------------------------------------------------------
 *
 * mouse3dMainInit  --  Initialization codel (fIDS, ...)
 *
 * Description:
 *
 * Returns:    OK or ERROR
 */

STATUS
mouse3dMainInit(int *report)
{

  return OK;
}

/*------------------------------------------------------------------------
 *
 * mouse3dMainEnd  --  Termination codel
 *
 * Description:
 *
 * Returns:    OK or ERROR
 */

STATUS
mouse3dMainEnd(void)
{
  spnav_close();
  isInitialized = 0;
  return OK;
}

/*------------------------------------------------------------------------
 *
 * mouse3dMainPerm  --  codel of permanent activity
 *
 * Description:
 *
 * Reports:      OK
 *              S_mouse3d_CANNOT_READ_DEVICE
 *
 * Returns:    OK or ERROR
 */

STATUS
mouse3dMainPerm(int *report)
{
  if(isInitialized == 0) {
    return OK;
  }
  spnav_poll_event(&mouse3d);
  SDI_F->measures.x = mouse3d.motion.x - SDI_F->offset.x;
  SDI_F->measures.y = mouse3d.motion.y - SDI_F->offset.y;
  SDI_F->measures.z = mouse3d.motion.z - SDI_F->offset.z;
  SDI_F->measures.Rx = mouse3d.motion.rx - SDI_F->offset.Rx;
  SDI_F->measures.Ry = mouse3d.motion.ry - SDI_F->offset.Ry;
  SDI_F->measures.Rz = mouse3d.motion.rz - SDI_F->offset.Rz;

  if(mouse3d.button.press == 1 ) {
    while(mouse3d.button.press == 1) {
      spnav_poll_event(&mouse3d);
    }
    if(mouse3d.button.bnum == 0) {
      if(SDI_F->measures.b0 == 0) {
        SDI_F->measures.b0 = 1;
      } else {
        SDI_F->measures.b0 = 0;
      }
    }
    if(mouse3d.button.bnum == 1) {
      if(SDI_F->measures.b1 == 0) {
        SDI_F->measures.b1 = 1;
      } else {
        SDI_F->measures.b1 = 0;
      }
    }
  }
  return OK;
}
/*------------------------------------------------------------------------
 * Init
 *
 * Description:
 *
 * Reports:      OK
 *              S_mouse3d_DEVICE_NOT_FOUND
 */

/* mouse3dInitMain  -  codel EXEC of Init
   Returns:  EXEC END ETHER FAIL ZOMBIE */
ACTIVITY_EVENT
mouse3dInitMain(int *report)
{
 if(spnav_open()==-1) {
   fprintf(stderr, "failed to connect to the space navigator daemon\n");
   return ETHER;
 }
 SDI_F->offset.x =0.0;
 SDI_F->offset.y =0.0;
 SDI_F->offset.z =0.0;
 SDI_F->offset.Rx =0.0;
 SDI_F->offset.Ry =0.0;
 SDI_F->offset.Rz =0.0;
 SDI_F->measures.b0 = 0;
 SDI_F->measures.b1 = 0;
 isInitialized = 1;
 printf("3dConnexion mouse Initialized\n");
 return ETHER;
}


